{smcl}
{cmd:help mcmcmahal} 
{hline}

{title:Title}

{p2colset 5 18 20 2}{...}
{p2col :{hi:mcmcmahal} {hline 2}}Convergence checking for a set of parameters{p_end}
{p2colreset}{...}


{title:Syntax}

{phang2}
{cmd:mcmcmahal}
{varlist} 
{ifin}
[{cmd:,} {it:options}]

{synoptset 20}{...}
{synopthdr}
{synoptline}
{synopt:{opth d:istance(varname)}}variable for saving the distances{p_end}
{synopt:{opt replace}}overwrite the distance {it:varname} if it exists{p_end}
{synopt:{opt nop:lot}}suppresses the plot{p_end}
{synopt:{opt gopt:ions(string)}}any {helpb twoway_options:twoway} options to
affect rendition of the individual plots{p_end}
{synopt:{opt cgopt:ions(string)}}any {helpb graph combine} options to affect
rendition of combining plots{p_end}
{synoptline}
{p2colreset}{...}


{title:Description}

{pstd}
{cmd:mcmcmahal} is intended for checking the convergence of a set of
parameters simulated by an MCMC algorithm and stored in {varlist}. The
Mahalanobis distance is a squared measure of the distance between an
individual set of simulated parameters and the mean of the parameters over all
simulations. The measure allows for correlation between the parameters. The
command creates a combined plot containing trace ({helpb mcmctrace}) and cusum
({helpb mcmccusum}) plots of the distance, a chi-squared ({helpb qchi}) plot,
and an intervals plot ({helpb mcmcintervals}).


{title:Options}

{phang}
{opt distance(varname)} specifies the variable for saving the distances.

{phang}
{opt replace} specifies that the distance {it:varname} be overwritten
if it exists.

{phang}
{opt noplot} suppresses the plot.

{phang}
{opt goptions(string)} are any of the {helpb twoway_options:twoway} options
for controlling the separate plots. 

{phang}
{opt cgoptions(string)} are any of the {helpb graph combine} options to
control the combining of the plots. 


{title:Example}

{phang}{cmd:. mcmcmahal b1-b20, distance(d)}{p_end}


{title:Author}

{pstd}
John Thompson{break}
Department of Health Sciences{break}
University of Leicester, UK{break}

{pstd}
Please report any errors to
{browse "mailto:john.thompson@le.ac.uk":john.thompson@le.ac.uk}.
{p_end}
