{smcl}
{* *! version 1.0.0  dec2012}{...}
{cmd:help tomodel} 
{hline}

{title:Title}

{p2colset 5 16 18 2}{...}
{p2col :{hi:tomodel} {hline 2}}Copy a WinBUGS model to a text file{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 16 2}
{cmd:tomodel} {it:thisfile modelfile} [{it:identifier}]

{phang}{it:thisfile} is the path to the do-file containing the command.{p_end}
{phang}{it:modelfile} is the destination to which the model file is written.
{p_end}
{phang}{it:identifier} is an optional, extra identifier{p_end}


{title:Description}

{pstd}
{cmd:tomodel} copies some WinBUGS syntax commands to a text file (model file).
In this way, the do-file can act as a record of the exact model file that was
used when calling WinBUGS from within Stata. The WinBUGS code must follow the
{cmd:tomodel} command line and be commented out using {cmd:/* ... */}. In this
way, the WinBUGS code is copied to the model file but the commenting stops
Stata from trying to run those lines.  The program works by rereading the
do-file until this {cmd:tomodel} command is found, and then its writes
anything that follows and is commented out to {it:modelfile}. Specifying the
name of the model file will usually uniquely define the command line that
marks the starting position.  However, if you have a do-file with several
inserted sections of WinBUGS code and you choose to write them to model files
with the same name, then it will need a further identifier to uniquely
determine the correcting starting position.


{title:Example}

            {cmd:tomodel this.do model.txt}
            {cmd:/*}
            {cmd:model {c -(}}
            {cmd:   ... }
            {cmd:{c )-} }
            {cmd:*/}


{title:Author}

{pstd}
John Thompson{break}
Department of Health Sciences{break}
University of Leicester, UK{break}

{pstd}
Please report any errors to
{browse "mailto:john.thompson@le.ac.uk":john.thompson@le.ac.uk}.
{p_end}
