{smcl}
{* *! version 1.0.0  22May2006}{...}
{cmd:help wbscoda} 
{hline}

{title:Title}

{p2colset 5 16 18 2}{...}
{p2col :{hi:wbscoda} {hline 2}}Read data from coda files created by WinBUGS or OpenBUGS into Stata{p_end}
{p2colreset}{...}


{title:Syntax}

{phang2}
{cmd:wbscoda} [{cmd:using} {it:{help filename}}]{cmd:,}
{opt clear}
[{it:options}]

{synoptset 20 tabbed}{...}
{synopthdr}
{synoptline}
{p2coldent:* {opt clear}}clears data from memory{p_end}
{synopt:{opth c:hains(numlist)}}list of chain numbers{p_end}
{synopt:{opt k:eep(string)}}list of parameters to be read{p_end}
{synopt:{opt o:penbugs}}coda files produced by OpenBUGS{p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2}
* {cmd:clear} is required.


{title:Description}

{pstd}
{cmd:wbscoda} reads data from WinBUGS or OpenBUGS coda files into Stata.  The
variable names are taken from the index file and the values from the data
files.  Any data currently in Stata will be lost, so you must specify the
{cmd:clear} option. WinBUGS programmers often use a full stop in the variable
name, as in {cmd:y.sigma}, which would be changed to {cmd:y_sigma} in Stata.


{title:Options}

{phang}
{opt clear} clears the data from memory.  {cmd:clear} is required.

{phang}
{opth chains(numlist)} specifies that when more than one chain was run, this
option specified the chain numbers to be read.

{phang}
{opt keep(string)} specifies the list of parameters to be read into
Stata. The list must relate to the parameters' WinBUGS names. Partial matches
are read, such that {cmd:keep(a)} would read parameters {cmd:alpha},
{cmd:a[1]}, etc. If {cmd:keep()} is not specified, then all variables are
read.

{phang}
{opt openbugs} specifies coda files be created by OpenBUGS. If 
{cmd:openbugs} is not specified, WinBUGS coda files will be created.


{title:Example}

{pstd}
Data in coda files for a single chain with root {cmd:myout}{p_end}
{phang2}{cmd:. wbscoda using myout, clear}{p_end}


{title:Additional software}

{pstd}
The WinBUGS Manual is available from {browse www.mrc-bsu.cam.ac.uk/bugs}.
Information about OpenBUGS is available from {browse www.openbugs.net/}.
See {search winbugs} for a list of all the commands for running WinBUGS from
Stata.


{title:Author}

{pstd}
John Thompson{break}
Department of Health Sciences{break}
University of Leicester, UK{break}

{pstd}
Please report any errors to
{browse "mailto:john.thompson@le.ac.uk":john.thompson@le.ac.uk}.
{p_end}
