set more off
*------------------------------
* Code for Chapter 1
* One eps but no dof
*------------------------------
set scheme sj
clear
*------------------------------
* Prior
*------------------------------
set obs 2
input x1 y1 x2 y2 x3 y3
0.3 5 0.3 0 0.5 0 
0.5 5 0.3 5 0.5 5
twoway (line y1 x1, lpat(solid)) ///
 (line y2 x2, lpat(solid)) ///
 (line y3 x3, lpat(solid)), ///
 xtitle(theta) ytitle(" ") xscale(range(0 0.6)) xlabel(0(0.1)0.6) ///
 legend(off)  yscale(range(0 7)) ylabel(0(2)6) title(Prior) nodraw
graph save temp/plot1.gph, replace
*------------------------------
* Posterior
*------------------------------
clear
set obs 1000
gen x1 = 0.3+(_n-1)*0.2/999
gen y1 = x1^5*(1-x1)^5
integ y1 x1
replace y1 = y1/r(integral)
gen x2 = 0.3 if _n <= 2
gen y2 = 0 if _n == 1
replace y2 = y1[1] if _n == 2
gen x3 = 0.5 if _n <= 2
gen y3 = 0 if _n == 1
replace y3 = y1[1000] if _n == 2
twoway (line y1 x1, lpat(solid)) ///
 (line y2 x2, lpat(solid)) ///
 (line y3 x3, lpat(solid)), ///
 xtitle(theta) ytitle(" ") xscale(range(0 0.6)) xlabel(0(0.1)0.6) ///
 legend(off) yscale(range(0 7)) ylabel(0(2)6) title(Posterior) nodraw
graph save temp/plot2.gph, replace
*------------------------------
* Combine plots and export
*------------------------------
graph combine temp/plot1.gph temp/plot2.gph 
* FIGURE 1.1
graph export "eps/chap1_1.eps", replace
